/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2008 by Witz Corporation, JAPAN
 *  Copyright (C) 2014 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */

/*
 *		sil.h vZbTˑ(RL78t@~ʕ)
 */

#ifndef TOPPERS_PRC_SIL_H
#define TOPPERS_PRC_SIL_H

/*
 *  RpC Inline T|[gȂ
 *  W̃ԃANZX֐gpȂ
 */
#define TOPPERS_OMIT_SIL_ACCESS

/*
 * PSW WX^
 */
#define PSW_IE_MASK 	(0x80)
#define PSW_ISP_MASK	(0x06)

// psw  ISP{0,1} o
#define PSW2ISP(psw)	((uint8_t)((psw) & PSW_ISP_MASK))
// psw  ISP{0,1} ̃rbgʒu isp Zbgp^[
#define PSW_SET_ISP(psw, isp)	((uint8_t)((uint8_t)(psw & ~PSW_ISP_MASK) | isp))


#ifndef TOPPERS_MACRO_ONLY

// PSW̎擾Eݒ
extern uint8_t get_psw(void);
extern void set_psw(uint8_t psw);

/*
 *  NMIׂĂ݂̊̋֎~(prc_config.c)
 */
extern uint8_t TOPPERS_disint(void);

/*
 *  ݗDx}XNi\ǰݒl̐ݒ(prc_config.c)
 */
extern void TOPPERS_enaint(uint8_t TOPPERS_psw);

/*
 *  S݃bNԂ̐
 */
#define SIL_PRE_LOC		uint8_t TOPPERS_ie_psw;
#define SIL_LOC_INT()	((void)(TOPPERS_ie_psw = TOPPERS_disint()))
#define SIL_UNL_INT()	(TOPPERS_enaint(TOPPERS_ie_psw))

/*
 *  ԑ҂(target_support.asm, not yet)
 */
extern void sil_dly_nse(ulong_t dlytim);

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  vZbT̃GfBA
 */
#define SIL_ENDIAN_LITTLE			/* gGfBA */

#endif /* TOPPERS_PRC_SIL_H */
